// C Source File
// Created 6/4/00; 2:47:48 PM

// #define USE_GRAY_PATCH
// #define USE_LONGMUL_PATCH
// #define USE_LONGDIV_PATCH
 #define USE_INITS_PATCH

#define SAVE_SCREEN

#include <nostub.h>  // Make NoStub Program
#include <all.h>     // Include All Header Files
#include "sprites.h"

#define kEsc 264
#define kUp 338
#define kLeft 337
#define kDown 344
#define kRight 340
#define kF1 268
#define kF2 269
#define die -1
#define win -2


int _ti92plus;       // Produce .9XZ File
void drawmap();
void drawcursor();
int clear();
void flag();
ti_float flags=FLT(10);
int score=0;
int highscore=999;

// Main Function
int _main()
{
	int a=0,row,col,currow=0,curcol=0,mines=0;
	long tilemap[8][8];
	long sprites[]={(long)&sprite00,(long)&sprite01,(long)&sprite01,(long)&sprite03,(long)&sprite03,
				 	 (long)&sprite05,(long)&sprite05,(long)&sprite00,(long)&sprite00,(long)&sprite00,
				 	 (long)&sprite0A,(long)&sprite0B,(long)&sprite00,(long)&sprite00,(long)&sprite00,
				 	 (long)&sprite00,(long)&sprite00,(long)&sprite11,(long)&sprite12,(long)&sprite13,
				 	 (long)&sprite14,(long)&sprite15,(long)&sprite16,(long)&sprite17,(long)&sprite18};
// Initialize the TileMap
	for (row=0;row!=8;row++){
		for (col=0;col!=8;col++){
			tilemap[row][col]=1;
		}
	}
	randomize();
	score=0;
	flags=FLT(10);
	while (mines!=10)
	{
		int r,c;
		r=random(8);
		c=random(8);
		if (r==0&&c==0)
			continue;
		if (tilemap[r][c]==2)
			continue;
		mines++;
		tilemap[r][c]=2;
	}
	
	DlgMessage("Mines92+","Mines92+ by Sean Barnes\n\nVersion 1.0\n\n"
		"  VertigoAce Programming",BT_NONE,BT_NONE);

// Draw the map
	drawmap(tilemap,sprites);
// Draw the cursor
	drawcursor(currow,curcol);
	FontSetSys(F_8x10);
	printf_xy(150,5,"Mines92+");
	printf_xy(150,20,"Flags: %f",flags);
	OSFreeTimer(USER_TIMER);
	OSRegisterTimer(USER_TIMER,1*20);
	while(1)
	{
		int key=kbhit();
		printf_xy(150,35,"Time: %d",score);
		printf_xy(150,50,"High: %d",highscore);
		if (OSTimerExpired(USER_TIMER))
			score++;
		if (key)
			ngetchx();
		if (!key)
			continue;
		if (key==kEsc)
			break;
		if (key==kUp)
			if (currow!=0)
				currow-=1;
		if (key==kRight)
			if (curcol!=7)
				curcol+=1;
		if (key==kDown)
			if (currow!=7)
				currow+=1;
		if (key==kLeft)
			if (curcol!=0)
				curcol-=1;
		if (key==kF1)
		{
			a=clear(currow,curcol,tilemap);
			if (a==die || a==win)
				break;
		}
		if (key==kF2)
			flag(currow,curcol,tilemap);
		if (key==0)
			continue;
		drawmap(tilemap,sprites);
		drawcursor(currow,curcol);
		printf_xy(150,5,"Mines92+");
		printf_xy(150,20,"Flags: %f",flags);
	}
	if (a==win)
	{
		ClrScr();
		printf_xy(5,5,"You won!");
		if (score<highscore)
		{
			printf_xy(5,20,"High score!: %d",score);
			highscore=score;
		}
		ngetchx();
	}
	if (a==die)
	{
		ClrScr();
		for (row=0;row!=8;row++)
			for (col=0;col!=8;col++)
			{
				if (tilemap[row][col]==2||tilemap[row][col]==6)
					tilemap[row][col]=10;
				if (tilemap[row][col]==3)
					tilemap[row][col]=11;
				if (tilemap[row][col]==5)
					tilemap[row][col]=1;
			}
		drawmap(tilemap,sprites);
		ngetchx();
		ClrScr();
		printf_xy(5,5,"You died...");
		ngetchx();
	}
	return 0;
}

void drawcursor(int row,int col)
{
	Sprite16(col*16,row*16,16,(void*)&curmask,LCD_MEM,SPRT_AND);
	Sprite16(col*16,row*16,16,(void*)&cursor,LCD_MEM,SPRT_OR);
	return;
}

void drawmap(long* tilemap,long* sprites)
{
	int row,col;
    long* spr=sprites;
    long* map=tilemap;
	ClrScr();
	for (row=0;row!=8;row++){
		for (col=0;col!=8;col++){
			long sprnum=map[row*8+col];
			Sprite16(col*16,row*16,16,(void*)spr[sprnum],LCD_MEM,SPRT_XOR);
		}
	}
}

int clear(int row, int col, long* tilemap)
{
	long* map=tilemap;
	int count=0,curval=map[row*8+col];

	if (curval==2||curval==6)
		return die;
	if (curval!=1 && curval!=5)
		return 0;
	if (row!=0&&col!=0)
		if (map[(row-1)*8+(col-1)]==2||map[(row-1)*8+(col-1)]==4||map[(row-1)*8+(col-1)]==6)
			count+=1;
	if (row!=0&&col!=7)
		if (map[(row-1)*8+(col+1)]==2||map[(row-1)*8+(col+1)]==4||map[(row-1)*8+(col+1)]==6)
			count+=1;
	if (row!=7&&col!=0)
		if (map[(row+1)*8+(col-1)]==2||map[(row+1)*8+(col-1)]==4||map[(row+1)*8+(col-1)]==6)
			count+=1;
	if (row!=7&&col!=7)
		if (map[(row+1)*8+(col+1)]==2||map[(row+1)*8+(col+1)]==4||map[(row+1)*8+(col+1)]==6)
			count+=1;
	if (row!=0)
		if (map[(row-1)*8+col]==2||map[(row-1)*8+col]==4||map[(row-1)*8+col]==6)
			count+=1;
	if (row!=7)
		if (map[(row+1)*8+col]==2||map[(row+1)*8+col]==4||map[(row+1)*8+col]==6)
			count+=1;
	if (col!=0)
		if (map[row*8+(col-1)]==2||map[row*8+(col-1)]==4||map[row*8+(col-1)]==6)
			count+=1;
	if (col!=7)
		if (map[row*8+(col+1)]==2||map[row*8+(col+1)]==4||map[row*8+(col+1)]==6)
			count+=1;
	curval=count+0x10;
	map[row*8+col]=curval;

// Clear blank space
	if (count==0)
	{
		if (row!=0)
		{
			clear(row-1,col,tilemap);
			if (col!=0)
				clear(row-1,col-1,tilemap);
			if (col!=7)
				clear(row-1,col+1,tilemap);
		}
		if (row!=7)
		{
			clear(row+1,col,tilemap);
			if (col!=0)
				clear(row+1,col-1,tilemap);
			if (col!=7)
				clear(row+1,col+1,tilemap);
		}
		if (col!=0)
			clear(row,col-1,tilemap);
		if (col!=7)
			clear(row,col+1,tilemap);
	}
				
// Check for win
	for (row=0;row!=8;row++)
		for (col=0;col!=8;col++)
		{
			if (map[row*8+col]==1)
				return 0;
			if (map[row*8+col]==3)
				return 0;
			if (map[row*8+col]==5)
				return 0;
		}
	return win;
}

void flag(int row, int col, long* tilemap)
{
	long* map=tilemap;
	int curval=map[row*8+col],newval;
	newval=curval;
	if (curval==01 || curval==02 ||curval==03 || curval==04)
		newval=curval+2;
	else if (curval==5 || curval==6)
		newval=curval-4;
	map[row*8+col]=newval;
	if (newval==3||newval==4)
		flags=fsub(flags,FLT(1));
	if (newval==5||newval==6)
		flags=fadd(flags,FLT(1));
}
